/** @file   ex046.c Demo-Programm fuer aktuelles Verzeichnis unter POSIX

ex046

*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <direct.h>

/** Hauptprogramm.
    @return 0 bei Erfolg, alle anderen Werte zeigen Fehler an.
*/
int
main(void)
{
    char  buf[_MAX_PATH];
    int   exc =   EXIT_FAILURE;

    /* Aktuelles Verzeichnis ermitteln. */
    if (NULL == _getcwd(buf, sizeof(buf))) {
        fputs(
            "FEHLER: Aktuelles Verzeichnis konnte nicht ermittelt werden!\n",
            stderr
        );
        fflush(stderr);
        goto finished;
    }

    /* Verzeichnis ausgeben. */
    if (EOF == fputs(buf, stdout)) {
        fputs(
            "FEHLER: Ein-/Ausgabefehler beim Schreiben des Verzeichnisnamens!\n",
            stderr
        );
        fflush(stderr);
        goto finished;
    }

    /* Zeilenende ausgeben. */
    if (EOF == fputc('\n', stdout)) {
        fputs(
            "FEHLER: Ein-/Ausgabefehler beim Schreiben des Newline!\n",
            stderr
        );
        fflush(stderr);
        goto finished;
    }

    /* Erfolg vermerken */
    exc = EXIT_SUCCESS;

finished:
    exit(exc); return exc;
}

/* vim: set ai sw=4 ts=4 expandtab : */
