/** @file ex052.c Demo-Programm zur Verwendung von union.
*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#include <stdio.h>

/**	Union-Typ un.
	Nur ein Element des union kann einen gueltigen Wert haben.
	Aendern/Setzen eines Elementes zerstoert den Inhalt der anderen
	Elemente.
*/
union un {
    int    i;		    /**< Ganzzahliger Wert. */
    double f;		    /**< Gleitkomma-Wert. */
    long   l;		    /**< Langer ganzzahliger Wert. */
    char   string[5];	/**< Text. */
};

/**	Struct-Typ st.
	Alle Elemente des struct haben gleichzeitig gueltige Werte.
	Aendern/Setzen eines Elementes beeinflusst die anderen Elemente nicht.
*/
struct st      {
    int    i;		/**< Ganzzahliger Wert. */
    long   l;		/**< Langer ganzzahliger Wert. */
    double f;		/**< Gleitkomma-Wert. */
};

/** Hauptprogramm.
    @return 0 bei Erfolg
*/
int
main(void)
{
    union  un	u1;	/* Definition der union-Variablen u1 */
    struct st	s1;	/* Definition der struct-Variablen s1 */

    printf("\nUnion\n");
    u1.i = 17;
    printf("%d\n",u1.i);		/*  1 */
    u1.l = 182;
    printf("\n%d\n",u1.i);		/*  2 */
    printf("%ld\n",u1.l);		/*  3 */
    u1.f= 15.;
    printf("\n%ld\n",u1.i);		/*  4 */
    printf("%ld\n",u1.l);		/*  5 */
    printf("%f\n",u1.f);		/*  6 */
    printf("\nStruktur:\n");
    s1.i = 17;
    printf("%d\n",s1.i);		/*  7 */
    s1.l = 182;
    printf("\n%d\n",s1.i);		/*  8 */
    printf("%ld\n",s1.l);		/*  9 */
    s1.f= 15.;
    printf("\n%d\n",s1.i);		/* 10 */
    printf("%ld\n",s1.l);		/* 11 */
    printf("%f\n",s1.f);		/* 12 */

    return 0;
}

/* vim: set ai sw=4 ts=4 expandtab : */
