/*	ex079.c
	Unterschied zwischen String als Array und String-Pointer.
*/

#define	_CRT_SECURE_NO_WARNINGS 1
#include <stdio.h>
#include <string.h>

/*	Zwei Strings, die als Arrays ta1 und ta2 angelegt werden. Veraenderlich.
*/
char ta1[] = { "Morgen ist Freitag, danach ist Wochenende." };
char ta2[] = { "Heute ist Donnerstag." };

/*	Zwei Strings, die als Pointer ts1 und ts2 auf anonyme Array angelegt werden.
	Der C-Compiler bringt die anonymen Arrays in nur lesbarem Speicher unter.
*/
char *tp1 = "Morgen ist Freitag, danach ist Wochenende.";
char *tp2 = "Heute ist Donnerstag.";

int
main(void)
{
	/*	Die Arrays ta1 und ta2 werden als normale Felder von char
		angelegt, beide Felder sind les- und schreibbar.
		Das Ueberschreiben von ta1 ergibt kein Problem.
	*/
	printf("ta2 nach ta1 kopieren:\n");
	fflush(stdout);
	strcpy(ta1, ta2);
	printf("%s\n\n", ta1);
	fflush(stdout);

	/*	Die Zeiger tp1 und tp2 zeigen auf anonyme Arrays, die der
		C-Compiler in nur lesbarem Speicher unterbringt.
		Ein Versuch, das Array zu aender, auf das tp1 zeigt, fuehrt
		zu einer Speicherschutzverletzung.
	*/
	printf("tp2 nach tp1 kopieren (fuehrt zu Speicherschutzverletzung):\n");
	fflush(stdout);
	strcpy(tp1, tp2);
	printf("%s\n\n", tp1);
	fflush(stdout);

	return 0;
}

/* vim: set ai sw=4 ts=4 : */
