/**	@file	he-ulongfo.c	Unsigned long in Datei ausgeben.
*/

/* Copyright (C) 2014 - HS Schmalkalden. All rights reserved. */

#include "he-conf.h"

#include <stdio.h>
#if HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if HAVE_STDINT_H
#include <stdint.h>
#endif
#if HAVE_LIMITS_H
#include <limits.h>
#endif

#include "he-ulongso.h"
#include "he-ulongfo.h"
#include "he-error.h"
#include "he-file.h"


int
hsm_et_ulong_to_file(FILE *of, unsigned long ul, const char *fn, int *ec)
{
  char          buffer[4 * (sizeof(long) + 4)]; /* Temporaerer Puffer */
  int           back    =   0;                  /* Ergebnis */
  if (NULL != of) {
    if (0 != hsm_et_ulong_to_string(buffer, sizeof(buffer), ul, ec)) {
      if (0 != hsm_et_file_puts(of, buffer, fn, ec)) {
        back = 1;
      }
    }
  } else {
    hsm_et_error_set(ec, HE_ERROR_INVALID_ARGS);
  }
  return back;
}


/* vim: set ai sw=4 ts=4 expandtab : */

