/** @file   ex041.c Demo-Programm zum Zugriffsrechte setzen fuer POSIX.

ex041   <Datei>

*/

/* Copyright (C) 2014-2017 - HS Schmalkalden. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

/** Hauptprogramm.
	@param  argc    Anzahl der Kommandozeilen-Argumente.
	@param  argv    Feld mit den Kommandozeilen-Argumenten.
	@return 0 bei Erfolg, alle anderen Werte zeigen Fehler an.
*/
int
main(int argc, char *argv[])
{
	int   exc =   EXIT_FAILURE;
	/* Test Kommandozeilen-Argumente, 1 Argument (Dateiname) erforderlich. */
	if (2 != argc) {
		fputs("FEHLER: Falsche Anzahl an Kommandozeilenargumenten!\n", stderr);
		fflush(stderr);
		goto finished;
	}

	/* Rechte aendern */
	if (0 != chmod(argv[1], 0640)) {
		fprintf(
			stderr,
			"FEHLER: Rechteaenderung fuer \"%s\" fehlgeschlagen!\n",
			argv[1]
		);
		fflush(stderr);
		goto finished;
	}

	/* Erfolg vermerken */
	exc = 0;

finished:
	exit(exc); return exc;
}

/* vim: set ai sw=4 ts=4 : */
