/** @file   ex070.c Beispiel fuer NetUserGetInfo.
	Aufruf:
	ex070 <Nutzername>
*/

#ifndef UNICODE
#define UNICODE 1
#endif

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <lm.h>
#include <sddl.h>

int wmain(int argc, wchar_t *argv[])
{
  int		        exval	=	EXIT_FAILURE;
  LPUSER_INFO_4	    pbuf4	=	NULL;
  NET_API_STATUS    res;

  /* Testen, ob Nutzername angegeben */
  if (2 != argc) {
	/* !!! FEHLER: Falsche Argumente-Anzahl, nur ein Argument erlaubt.
	*/
	goto finished;
  }

  /* Versuch, Informationen ueber Nutzer zu erhalten. Test auf Erfolg. */
  res = NetUserGetInfo(NULL, argv[1], (DWORD)4, (LPBYTE *)(&pbuf4));
  if (NERR_Success != res) {
	/* !!! FEHLER: Abruf der Informationen fehlgeschlagen.
	*/
	goto finished;
  }

  /* Gefundene Informationen ausgeben */
  if (NULL != pbuf4->usri4_name) {
	wprintf(L"Login-Name:   %s\n", pbuf4->usri4_name);
  }
  if (NULL != pbuf4->usri4_full_name) {
	wprintf(L"Voller Name:  %s\n", pbuf4->usri4_full_name);
  }
  if (NULL != pbuf4->usri4_comment) {
	wprintf(L"Kommentar:    %s\n", pbuf4->usri4_comment);
  }
  wprintf(L"Nutzer-Level: %d\n", pbuf4->usri4_priv);

  /* Datenpuffer wieder freigeben, falls Allokation erfolgte. */
  if (NULL != pbuf4) {
	NetApiBufferFree(pbuf4);
	pbuf4 = NULL;
  }

finished:
  exit(exval); return exval;
}

/* vim: set ai sw=4 ts=4 : */
