/**	@file   he-geom.h   Berechnungen fuer geometrische Objekte.

	Im Original enthaelt dieses Modul nur die Berechnung von
	Quadraten und Rechtecken.

	In den Uebungen werden durch die Studierenden Funktionen
	fuer Kreise und Dreiecke hinzugefuegt.
*/

/* Copyright (C) 2014 - HS Schmalkalden. All rights reserved. */

#ifndef HE_GEOM_H_INCLUDED
#define	HE_GEOM_H_INCLUDED	1

#ifdef __cplusplus
extern "C" {
#endif

/**	Flaecheninhalt eines Quadrates berechnen.
	@param	sl	Seitenlaenge.
	@return	Flaecheninhalt (nichtnegativ) bei Erfolg, -1.0 bei Fehler.
*/
double
hsm_et_geom_quadrat_flaeche(double sl);

/**	Flaecheninhalt eines Rechtecks berechnen.
	@param	sla	Seitenlaenge.
	@param	slb	Andere Seitenlaenge.
	@return	Flaecheninhalt (nichtnegativ) bei Erfolg, -1.0 bei Fehler.
*/
double
hsm_et_geom_rechteck_flaeche(double sla, double slb);

#ifdef __cplusplus
}
#endif

#endif
/* ifndef HE_GEOM_H_INCLUDED */

/* vim: set ai sw=4 ts=4 expandtab : */
