/**	@file   he-numco.h  Sicherstellen, dass Min/Max-Konstanten verfuegbar.
*/

/* Copyright (C) 2014 - HS Schmalkalden. All rights reserved. */

#ifndef	HE_NUMCO_H_INCLUDED
#define	HE_NUMCO_H_INCLUDED	1

#include "he-conf.h"

#if HAVE_STDLIB_H
#include <stdlib.h>
#endif

#if HAVE_STDINT_H
#include <stdint.h>
#endif

#if HAVE_LIMITS_H
#include <limits.h>
#endif


#ifndef LONG_MIN

/** Minimaler long-Wert.
*/
#define LONG_MIN    (-2147483647L - 1L)

#error  "Keine System-Definition fuer LONG_MIN"
/*  Wenn der Compiler diese Fehlermeldung zeigt, steht in den
    Header-Dateien Ihres Systems keine Definition fuer LONG_MIN.
    In der vorangegangenen define-Zeile wird ein Standardwert
    definiert. Diese Definition setzt voraus, dass long-Werte
    32 Bits (4 Bytes) benutzen.
    Verwendet Ihr Compiler eine andere Groesse fuer long, muss der
    Wert in der define-Zeile entsprechend angepasst werden.
    Anschliessend kann die error-Zeile entfernt werden.
*/

#endif
/* ifndef LONG_MIN */



#ifndef LONG_MAX

/** Maximaler long-Wert.
*/
#define LONG_MAX    (2147483647L)

#error  "Keine System-Definition fuer LONG_MAX"
/*  Wenn der Compiler diese Fehlermeldung zeigt, steht in den
    Header-Dateien Ihres Systems keine Definition fuer LONG_MAX.
    In der vorangegangenen define-Zeile wird ein Standardwert
    definiert. Diese Definition setzt voraus, dass long-Werte
    32 Bits (4 Bytes) benutzen.
    Verwendet Ihr Compiler eine andere Groesse fuer long, muss der
    Wert in der define-Zeile entsprechend angepasst werden.
    Anschliessend kann die error-Zeile entfernt werden.
*/
#endif
/* ifndef LONG_MAX */



#ifndef ULONG_MAX

/** Maximaler unsigned long Wert.
*/
#define ULONG_MAX (4294967295L)

#error  "Keine System-Definition fuer ULONG_MAX"
/*  Wenn der Compiler diese Fehlermeldung zeigt, steht in den
    Header-Dateien Ihres Systems keine Definition fuer ULONG_MAX.
    In der vorangegangenen define-Zeile wird ein Standardwert
    definiert. Diese Definition setzt voraus, dass long-Werte
    32 Bits (4 Bytes) benutzen.
    Verwendet Ihr Compiler eine andere Groesse fuer long, muss der
    Wert in der define-Zeile entsprechend angepasst werden.
    Anschliessend kann die error-Zeile entfernt werden.
*/

#endif
/* ifndef ULONG_MAX */



#endif
/* ifndef HE_NUMCO_H_INCLUDED */

/* vim: set ai sw=4 ts=4 expandtab : */

