/**	@file	he-time.h	Aktuellen Zeitpunkt in lokaler Zeitzone ermitteln.
*/

#ifndef	HE_TIME_H_INCLUDED
#define	HE_TIME_H_INCLUDED	1

/**	Portable Form fuer Datum und Uhrzeit.
*/
typedef struct {
	int	tag;		/**< Tag innerhalb des Monats, beginnt mit 1. */
	int	monat;		/**< Monat, beginnt mit 1. */
	int	jahr;		/**< Jahr, volle vierstellige Angabe. */
	int	stunde;		/**< Stunden, 0 bis 23. */
	int	minute;		/**< Minute, 0 bis 59. */
	int	sekunde;	/**< Sekunde, 0 bis 59. */
} he_time_t;

#ifdef	__cplusplus
extern "C" {
#endif

/**	Aktuelles Datum und aktuelle Uhrzeit in oben definierte Struktur eintragen.
	@param	dst	Zielstruktur, die gefuellt werden soll.
	@return	1 bei Erfolg, 0 bei Fehler.
*/
int
he_time_get(he_time_t *dst);

#ifdef	__cplusplus
}
#endif

#endif
/* ifndef HE_TIME_H_INCLUDED*/


/* vim: set ai sw=4 ts=4 : */

