/**	@file he-winkey.h	Keyboard-Abfrage fuer Windows.
*/

/* Copyright (C) 2014 - HS Schmalkalden. All rights reserved. */

#ifndef HE_WINKEY_H_INCLUDED
#define	HE_WINKEY_H_INCLUDED	1

#include "he-conf.h"

#if HE_ON_WINDOWS

#ifdef __cplusplus
extern "C" {
#endif

/** Keyboard-Abfrage fuer Windows.
    @return Tastencode fuer gedrueckte Taste.
*/
int
hsm_et_windows_key_get(void);

#ifdef __cplusplus
}
#endif

/** Tastatur-Codes.
*/
enum {
  /** Escape-Taste.
  */
  HE_WINKEY_ESC	=	27
};

#else
/* if HE_ON_WINDOWS */

#error "The hsm_et_windows_key_get() function is only available on Windows!"

#endif
/* if HE_ON_WINDOWS */

#endif
/* ifndef HE_WINKEY_H_INCLUDED */


/* vim: set ai sw=4 ts=4 expandtab : */
